#include <tchar.h>
#include <Windows.h>
#include <Objbase.h>

// C|[g
#import "Component.tlb" no_namespace named_guids raw_interfaces_only

// C
int main(int argc, char* argv[])
{
	IVector3	*a,*b,*c;
	ITestCom*	pTestCom; // COMC^[tFCX|C^

	// COM̏
	::CoInitialize(NULL);

	// CX^X̍쐬(CLSIDIIDw肵āACX^X擾)
	CoCreateInstance((REFCLSID) CLSID_TestCom, 0, CLSCTX_ALL,
		(REFIID)  IID_ITestCom, (LPVOID*)&pTestCom);

	// CX^X̍쐬(CLSIDIIDw肵āACX^X擾)
	CoCreateInstance((REFCLSID) CLSID_Vector3, 0, CLSCTX_ALL,
		(REFIID)  IID_IVector3, (LPVOID*)&a);

	// CX^X̍쐬(CLSIDIIDw肵āACX^X擾)
	CoCreateInstance((REFCLSID) CLSID_Vector3, 0, CLSCTX_ALL,
		(REFIID)  IID_IVector3, (LPVOID*)&b);

	// CX^X̍쐬(CLSIDIIDw肵āACX^X擾)
	CoCreateInstance((REFCLSID) CLSID_Vector3, 0, CLSCTX_ALL,
		(REFIID)  IID_IVector3, (LPVOID*)&c);

	long out;
	pTestCom->Add(10,15,&out);
	printf("%d\n",out);
	a->SetVector3(1.0f,2.0f,3.0f);
	b->SetVector3(3.0f,4.0f,5.0f);
	pTestCom->AddVec(a,b,&c);
	float x,y,z;
	c->GetVector3(&x,&y,&z);
	printf("%f,%f,%f\n",x,y,z);

	c->Release();
	b->Release();
	a->Release();
	pTestCom->Release();

	// COM̏I
	::CoUninitialize();

	return 0;
}